/*
 *  The Lion Game - Text based adventure based on the adventures of Flinny the Lion
    Copyright (C) 2014 Adam Belcher

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

 * 
 */

package game;
import game.entities.GameObject;
import game.entities.animals.Wildebeest;
import game.entities.animals.Zebra;
import game.entities.animals.enemies.Enemy;
import game.entities.animals.enemies.Hyena;

import java.util.Random;

public class Spawn {

	public static int zebraLevel = 1;
	public static int wildebeestLevel = 3;
	public static int hyenaLevel = 5;
	
	public static GameObject spawnRandomPassive(){
		GameObject animal;
		Random r = new Random();
		
		int a = r.nextInt(2);
		if (a == 1 && Start.player.level >= wildebeestLevel){
			animal = spawnWildebeest();
		}else{
			animal = spawnZebra();
		}
		return animal;
	}
	
	public static Enemy spawnEnemy(){
		Enemy e = null;
		
		if (Start.player.level >= hyenaLevel){
			e = spawnHyena();
		}
		
		return e;
	}
	
	public static Zebra spawnZebra(){
		Zebra zebra = new Zebra(10, 60, 12, 300, false);
		return zebra;
	}
	
	public static Wildebeest spawnWildebeest(){
		Wildebeest wildebeest = new Wildebeest(20, 75, 12, 600, false);
		return wildebeest;
	}
	
	public static Hyena spawnHyena(){
		Hyena h = new Hyena(20, 15, 12, 1000, 2, 5, 2);
		return h;
	}
	
	public static Hyena spawnBossHyena(){
		Hyena h = new Hyena(100, 40, 12, 10000, 8, 15, 10);
		return h;
	}
}
