/*
 *  The Lion Game - Text based adventure based on the adventures of Flinny the Lion
    Copyright (C) 2014 Adam Belcher

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

 * 
 */

package game;
import game.entities.GameObject;
import game.entities.player.Player;
import game.events.EmptyEvent;
import game.world.Environment;

import java.util.ArrayList;

public class Start {
	
	public static Player player;
	public static Environment environ;
	public static EmptyEvent firstEvent;
	public static boolean gameOver = false;
	public static ArrayList <GameObject> objects;
	
	public static void main(String[] args) {
		
		System.out.println("Starting Lion Game Beta 1.0 \n");
		
		System.out.println("You are a lion and your goal is to survive. Here are some commands you can use:");
		System.out.println("attack");
		System.out.println("eat");
		System.out.println("search");
		System.out.println("drink");
		System.out.println("sleep");
		System.out.println("chase");
		System.out.println("For more commands, type 'help'.\n");
		
		player = new Player();
		
		objects = new ArrayList<GameObject>();
		objects.add(player);
		environ = new Environment();
		
		eventLoop();
		
	}
	
	public static void eventLoop(){
		firstEvent = new EmptyEvent("You are in the middle of an empty plain. It is early morning.");
		firstEvent.start();
		
		if (!gameOver) eventLoop();
	}
	
	public static int power(int a, int b){
		int power = 1;
		for(int c=0;c<b;c++)
			power*=a;
		return power;
		//Sourced from StackOverflow
        }
}
