/*
 *  The Lion Game - Text based adventure based on the adventures of Flinny the Lion
    Copyright (C) 2014 Adam Belcher

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

 * 
 */

package game;
import game.entities.player.Player;
import game.entities.player.abilities.Ability;

import java.util.Scanner;

public class UserInput {
	
	public Scanner s;
	private boolean skipped;
	
	public UserInput(){
		s = new Scanner(System.in);
	}
	
	public int getInput(){
		
		String input;
		int commandID = 0;
		
		input = s.nextLine();
		input = input.toLowerCase();
		if (input.equals("exit")){
			commandID = 1;
		}else if (input.equals("wait")){
			commandID = 2;
		}else if(input.equals("attack")){
			commandID = 3;	
		}else if(input.equals("eat")){
			commandID = 4;
		}else if(input.equals("roar")){
			commandID = 5;
		}else if(input.equals("search")){
			commandID = 6;
		}else if(input.equals("drink")){
			commandID = 7;
		}else if(input.equals("leave")){
			commandID = 8;
		}else if(input.equals("stats")){
			commandID = 9;
		}else if(input.equals("credits")){	
			commandID = 10;
		}else if(input.equals("changelog")){
			commandID = 11;
		}else if(input.equals("help")){	
			commandID = 12;
		}else if(input.equals("chase")){
			commandID = 13;
		}else if(input.equals("sleep")){
			commandID = 14;
		}else if(input.equals("time")){
			commandID = 16;
		}else if(input.equals("rest")){
			commandID = 17;
		}else if(input.equals("stalk")){
			commandID = 18;
		}else if(input.equals("roam")){	
			commandID = 19;
		}else if(input.equals("approach")){
			commandID = 24;
		}else if(input.equals("ability")){
			commandID = 25;
		}else{
			System.out.println("That command does not exist, idiot.");
			commandID = getInput();
		}
		
		return commandID;
	
	}
	
	
	public int getAbility(){
		
		String input;
		int abilityID = 0;
		boolean success = false;
		
		System.out.println("What ability do you want to use? Type 'cancel' to go back.");
		
		for (Ability ability : Player.abilities){
			if (ability.unlocked){
				System.out.println(ability.name);
			}
		}
		
		input = s.nextLine();
		input = input.toLowerCase();
		
		if (input.equals("cancel")){
			return 404;
		}
		
		for (Ability ability : Player.abilities){
			if (input.equals(ability.name.toLowerCase()) && ability.unlocked){
				success = true;
				abilityID = ability.abilityID;
			}
		}
		
		if (success){
			return abilityID;
		}else{
			return getAbility();
		}
		
	}

	public int getSearchInput(){
		
		String input;
		int searchID = 0;
		
		System.out.println("What do you want to search for?");
		
		input = s.nextLine();
		input = input.toLowerCase();
		
		if (input.equals("cancel")){
			searchID = 1;
		}else if(input.equals("food")){
			searchID = 2;
		}else if(input.equals("water")){
			searchID = 3;
		}else if(input.equals("shelter")){
			searchID = 4;
		}else if(input.equals("fight")){
			searchID = 5;
		}else if(input.equals("boss")){
			searchID = 6;
		}else if(input.equals("exit")){
			return 1;
		}else if(input.equals("help")){
			System.out.println("Here are some things you can search for:");
			System.out.println("Food\nWater\nShelter");
			System.out.println("Use cancel to go back.");
			searchID = getSearchInput();
		}else{
			System.out.println("You cannot search for that.");
			searchID = getSearchInput();
		}
		
		return searchID;
	}
	
	public int getNumInput(){
		int input = 0;
		
		if (s.hasNextInt()){
			input = s.nextInt();
			s.nextLine();
		}else{
			s.nextLine();
			System.out.println("Please enter an integer.");
			input = getNumInput();
		}
		
		return input;
	}
	
	public boolean getYesNoInput(){
		boolean yesNo;
		String input;
		
		input = s.nextLine();
		input = input.toLowerCase();
		
		if(input.equals("yes")){
			yesNo = true;
		}else if (input.equals("no")){
			yesNo = false;
		}else{
			System.out.println("Please enter yes or no.");
			yesNo = getYesNoInput();
		}
		
		return yesNo;
	}
	

	public void selectAbility(){
	
		System.out.println("Type 'full' for a full list of all unlocked, available and locked abilities.");
		System.out.println("Type 'skip' if you want to save your unlock for the next time you level up.");
		
		for(Ability ability : Player.abilities){
			if (!ability.unlocked && ability.checkPrereq(true)){
				System.out.println(ability.name);
			}
		}
		
		Start.player.unusedUnlocks++;
		String input;
		boolean success = false;
		skipped = false;
		input = s.nextLine();
		input = input.toLowerCase();
		
		for(Ability ability : Player.abilities){
			String i = ability.name.toLowerCase();
			if(input.equals(i)){
				if(ability.unlocked){
					System.out.println("You have already unlocked this ability.");
				}
				if(!ability.unlocked && ability.checkPrereq(false)){
					System.out.println("You have unlocked " + ability.name);
					ability.unlock();
					success = true;
					Start.player.unusedUnlocks--;
				}
			}
		}
		
		if (input.equals("full")){
			System.out.println("Unlocked abilities:");
			for (Ability ability : Player.abilities){
				if (ability.unlocked){
					System.out.println(ability.name);
				}
			}
			System.out.println("Available abilities:");
			for (Ability ability : Player.abilities){
				if (!ability.unlocked && ability.checkPrereq(true)){
					System.out.println(ability.name);
				}
			}
			System.out.println("Locked abilities:");
			for (Ability ability : Player.abilities){
				if (!ability.unlocked && !ability.checkPrereq(true)){
					System.out.println(ability.name);
				}
			}
			System.out.println();
		}
		
		if (input.equals("skip")){
			success = true;
			skipped = true;
		}
		
		if (!success){
			System.out.println("Please enter an ability from the list.");
			selectAbility();
		}
		
		if (Start.player.unusedUnlocks > 0 && !skipped){
			System.out.println("There are unlocks left from previous level ups that you can use. Would you like to use them now?");
			if(getYesNoInput()){
				selectAbility();
			}
		}
		
	}

	public void selectAttributes(){
		
		String input;
		int points = 5;
		
		while(points > 0){
		
			System.out.println("Select an attribute to increase. You have " + points +" points to spend. Your current attributes:");
			System.out.println("Maximum health = " + Start.player.maxHealth);
			System.out.println("Speed = " + Start.player.speed);
			System.out.println("Stamina = " + Start.player.stamina);
		
			input = s.nextLine();
			input = input.toLowerCase();
			
			if(input.equals("maximum health")){
				Start.player.maxHealth += 5;
				points--;
			}else if(input.equals("speed")){
				Start.player.speed++;
				points--;
			}else if(input.equals("stamina")){
				Start.player.stamina++;
				points--;
			}else{
				System.out.println("Please choose one of the attributes.");
			}
		}
		
	}
	
}
