/*
 *  The Lion Game - Text based adventure based on the adventures of Flinny the Lion
    Copyright (C) 2014 Adam Belcher

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

 * 
 */

package game.entities;

public abstract class GameObject {

	public int health;
	public int maxHealth;
	public boolean isDead;
	public boolean diedThisTurn;
	public boolean isRunning;
	public int foodValue;
	public int xpValue;
	public int speed;
	public int stamina;
	public int energy;
	public int awareness;
	public String name;
	
	public void update(){
		
		if (health > maxHealth){
			health = maxHealth;
		}
		
		if (health > 0) isDead = false;
			
		if (health <= 0 && !isDead){
			isDead = true;
			diedThisTurn = true;
		}
	}
	
	public void create(){
		if (health > maxHealth){
			health = maxHealth;
		}
		
		if (health <= 0){
			isDead = true;
		}
	}
	
	public void damage(int damage){
		health = health - damage;
	}
	
}
