/*
 *  The Lion Game - Text based adventure based on the adventures of Flinny the Lion
    Copyright (C) 2014 Adam Belcher

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

 * 
 */

package game.entities.player.abilities;

import game.Start;

public class Pounce extends Ability {

	public Pounce() {
		name = "Pounce";
		unlockMsg = "You have unlocked the pounce attack. This is an attack that you can use when undetected, and it does massive damage.";
		abilityID = 4;
	}
	
	public void use(){
		
	}
	
	public boolean checkPrereq(boolean silent){
		if(Start.player.attackSkill >= 6 && Start.player.stealthSkill >= 5){
			return true;
		}else{
			if (!silent){
				System.out.println("Your attack skill must be at least 6 and your stealth skill at least 5 to unlock this ability.");
			}
			return false;
		}
	}

}
